'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _redux = require('redux');

exports['default'] = new ((function () {
  function _class() {
    var _this = this;

    _classCallCheck(this, _class);

    this.listeners = [];
    this.store = {};

    this.getStore = function () {
      return _this.store;
    };

    this.getState = function () {
      return _this.store.getState();
    };

    this.createStore = function () {
      _this.store = _redux.createStore.apply(undefined, arguments);

      _this.unSubscribe = _this.store.subscribe(_this.handleStoreUpdate);

      return _this.store;
    };

    this.connect = function () {
      var mapStateToProps = arguments.length <= 0 || arguments[0] === undefined ? null : arguments[0];
      var mapDispatchToProps = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];
      var singleton = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];
      return function (Clazz) {
        var clazzWrapper = function clazzWrapper() {
          var props = mapStateToProps !== null ? mapStateToProps(_this.getState()) : {};
          var actions = mapDispatchToProps !== null ? (0, _redux.bindActionCreators)(mapDispatchToProps, _this.store.dispatch) : {};

          var clazz = new Clazz(_extends({}, actions, props), function () {
            return _this.removeListener(clazz.constructor.name);
          });

          _this.listeners.push({
            clazz: clazz.constructor.name,
            receiveProps: clazz.receiveProps,
            mapStateToProps: mapStateToProps !== null ? mapStateToProps : function () {},
            props: props
          });

          return clazz;
        };

        if (singleton) {
          return new clazzWrapper();
        }

        return clazzWrapper;
      };
    };

    this.handleStoreUpdate = function () {
      var newState = _this.getState();

      _this.listeners = _this.listeners.map(function (listener) {
        var mapStateToProps = listener.mapStateToProps;
        var props = listener.props;
        var receiveProps = listener.receiveProps;

        var nextProps = mapStateToProps(newState);

        if (JSON.stringify(nextProps) !== JSON.stringify(props)) {
          receiveProps(nextProps);

          return _extends({}, listener, {
            props: _extends({}, nextProps)
          });
        }

        return listener;
      });
    };

    this.removeListener = function (clazzToRemove) {
      return _this.listeners = _this.listeners.filter(function (_ref) {
        var clazz = _ref.clazz;
        return clazz !== clazzToRemove;
      });
    };
  }

  return _class;
})())();
module.exports = exports['default'];